#include "StdAfx.h"
#include "Model.h"

// DEBUG_NEW macro allows MFC applications to determine memory leak locations in debug builds
#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

CModel::CModel()
:m_root_node( L"root node" )
,m_PtA(NULL) 
,m_PtB(NULL)
,m_Sphere(NULL)
{
  m_Sphere = new UWB_SceneNode( L"Sphere" );
  m_PtA = new UWB_SceneNode(L"PtA");
  m_PtB = new UWB_SceneNode(L"PtB");

  m_A = new UWB_SceneNode(L"A-Intersect");
  m_B = new UWB_SceneNode(L"B-Intersect");

  UWBD3D_PrimitiveMesh *m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m_Sphere->SetPrimitive(m);
  m->SetFillMode(fmWireframe);
  m->SetFlatColor(UWB_Color(255, 255, 255, 128));

  m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m_PtA->SetPrimitive(m);
  m->SetFlatColor(UWB_Color(255, 0, 0));

  m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m_PtB->SetPrimitive(m);
  m->SetFlatColor(UWB_Color(0, 255, 0));

  m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m->SetFlatColor(UWB_Color(0, 0, 0));
  m_A->SetPrimitive(m);

  m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m->SetFlatColor(UWB_Color(0, 0, 0));
  m_B->SetPrimitive(m);

  UWB_XformInfo xf = m_PtA->GetXformInfo();
  xf.SetScale(0.1f);
  m_A->SetXformInfo(xf);
  m_B->SetXformInfo(xf);
  
  m_Num = 0;

  
#define SIZE 3

  xf = m_Sphere->GetXformInfo();
  xf.SetScale(SIZE);
  m_Sphere->SetXformInfo(xf);

  xf = m_PtA->GetXformInfo();
  xf.SetScale(0.3f);
  xf.SetTranslation(vec3(10, 0, 0));
  m_PtA->SetXformInfo(xf);

  xf.SetTranslation(vec3(-10, 0, 0));
  m_PtB->SetXformInfo(xf);

  m_root_node.InsertChildNode( m_Sphere ); 
  m_root_node.InsertChildNode( m_PtA );
  m_root_node.InsertChildNode( m_PtB );

  m_TheLine.SetShadeMode(smFlat);
  m_TheLine.SetFlatColor(UWB_Color(0, 0, 0));
}

void CModel::DrawModel()
{
  UWBD3D_DrawHelper draw_helper;
  m_root_node.Draw( draw_helper.GetLOD(), draw_helper );

  vec3 pa = m_PtA->GetXformInfo().GetTranslation();
  vec3 pb = m_PtB->GetXformInfo().GetTranslation();

  m_TheLine.SetStartPoint(pa.x, pa.y, pa.z);
  m_TheLine.SetEndPoint(pb.x, pb.y, pb.z);

  m_TheLine.Draw(draw_helper.GetLOD(), draw_helper);

  if (m_Num >= 1) {
    m_A->Draw(draw_helper.GetLOD(), draw_helper);
    if (m_Num == 2)
      m_B->Draw(draw_helper.GetLOD(), draw_helper);
  }
}

UWB_SceneNode* CModel::GetRootNode()
{
  return &m_root_node;
}