// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once

/// The model separates the geometry and simulation of geometry interactions
/// from the user interface. Separation of the model from the user interface
/// generally leads to easier to maintain applications
class CModel
{
public:
  CModel();

  ///
  /// Draw all of the geometry that is part of this model.
  void DrawModel();

  ///
  /// Get the root node of the complete scene
  UWB_SceneNode* GetRootNode();
  void SetActiveSceneNode(UWB_SceneNode* node){}

  void UpdateSimulation();

private:

  UWB_SceneNode m_root_node;
  UWB_SceneNode *m_PtA, *m_PtB, *m_A, *m_B;
  UWB_SceneNode *m_Sphere;
  
  int m_Num;  // number of intersections

  // support real time clock
  UWB_Clock m_StopWatch;

  UWB_PrimitiveLine m_TheLine;    // line coordinates are in WC!
};
