#include "StdAfx.h"
#include "Model.h"

// DEBUG_NEW macro allows MFC applications to determine memory leak locations in debug builds
#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

void CModel::UpdateSimulation()
{
  float secondsPassed = m_StopWatch.GetSecondsElapsed();

  vec3 c, tv, lp1, lp2, v;

  float r = m_Sphere->GetXformInfo().GetScale().x;
  m_Sphere->GetXformInfo().SetScale(r);
  r = r * 2.0f;
 
  c = m_Sphere->GetXformInfo().GetTranslation();
  lp1 = m_PtA->GetXformInfo().GetTranslation();
  lp2 = m_PtB->GetXformInfo().GetTranslation();

  v = lp2 -lp1;
  tv = c - lp1;

  float len = length(v);
  v = v / len;
  float ptv = dot(tv, v);

  m_Num = 0;
  if ((ptv < (-r)) || (ptv > (len+r)))
    return;   // circle behind of infron of the line

  float r2 = r*r;  
  float d2 = length2(tv) - (ptv*ptv);

  if (d2 > r2)
      return;   // circle too far from line

  vec3 result[2];
  
  // if all we care is t/f at this point, we know we have a hit
  float d1 = sqrt(r2-d2);
  float dToI = ptv - d1;
  if ( (dToI > 0) && (dToI < len) ) {
      result[m_Num] = lp1 + (v * dToI);
      m_Num++;
  }
  dToI = ptv + d1;
  if ( (dToI < len) && (dToI > 0)) {
      result[m_Num] = lp1 + (v * dToI);
      m_Num++;
  }
  
  if (m_Num >= 1) {
      UWB_XformInfo xf = m_A->GetXformInfo();
      xf.SetTranslation(result[0]);
      m_A->SetXformInfo(xf);

      if (m_Num == 2) {
          xf = m_B->GetXformInfo();
          xf.SetTranslation(result[1]);;
          m_B->SetXformInfo(xf);
      }
  }



}