// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DResource1.h"
#include "uwbgl_Containers.h"
#include "uwbgl_Intersect4.h"
#include "uwbgl_Color1.h"

class UWBD3D_MeshResource : public UWBD3D_Resource
{
public:
  UWBD3D_MeshResource();
  ~UWBD3D_MeshResource();

  /// Draw the mesh that this resource contains
  /// \param material_color [in] If no texture exists for the mash material,
  ///        use the passed in material_color
  void DrawMesh( bool bUseTexture, bool bShowFlatColor, UWB_Color material_color );

  const UWB_BoundingBox* GetBoundingBox() const;

protected:
  virtual void ReleaseMemory(); 
  virtual bool LoadResourceFromFile(const wchar_t* fullPathName);
  
  ///
  /// The mesh object that this resource holds
  LPD3DXMESH                    m_Mesh;
  ///
  /// List of materials used by the mesh
  UWB_Array<D3DMATERIAL9>       m_MeshMaterials;
  ///
  /// List of textures used by the mesh
  UWB_Array<LPDIRECT3DTEXTURE9> m_MeshTextures;
  UWB_BoundingBox               m_bounds;
};
