#include "uwbgl_D3DPrimitiveMeshArrow3.h"
#include "uwbgl_D3DGraphicsSystem6.h"
#include "uwbgl_XformInfo5.h"

UWBD3D_PrimitiveMeshArrow::UWBD3D_PrimitiveMeshArrow()
{
}


void UWBD3D_PrimitiveMeshArrow::DrawPrimitive( eLevelOfDetail lod, UWB_DrawHelper& draw_helper )
{
  UWBD3D_GraphicsSystem& graphics = UWBD3D_GraphicsSystem::GetSystem();
  UWBD3D_MeshResource *pCylinderMesh, *pConeMesh;

  pCylinderMesh = graphics.GetMeshResource( L"cylinder.x" );
  pConeMesh     = graphics.GetMeshResource( L"cone.x" );

  if( pCylinderMesh && pConeMesh )
  {
    draw_helper.PushModelTransform();
    {
      const UWB_BoundingBox* box = pCylinderMesh->GetBoundingBox();
      UWB_XformInfo cylinder_xform;
      cylinder_xform.SetScale( vec3(0.025f, 0.025f, 0.8f / box->Depth() ) );
      cylinder_xform.UpdateRotationYByDegree(-90.0f);
      cylinder_xform.SetTranslation( vec3(0.40f, 0.0f, 0.0f) );
      cylinder_xform.SetUpModelStack( draw_helper );
      pCylinderMesh->DrawMesh(false,  /* no texture */
                    true /* show flat color */, m_FlatColor );
    }
    draw_helper.PopModelTransform();

    draw_helper.PushModelTransform();
    {
      const UWB_BoundingBox* box = pConeMesh->GetBoundingBox();
      UWB_XformInfo cone_xform;
      cone_xform.SetScale( vec3(0.08f, 0.08f, 0.3f / box->Depth() ) );
      cone_xform.UpdateRotationYByDegree(-90.0f);
      cone_xform.SetTranslation( vec3(0.85f, 0.0f, 0.0f) );
      cone_xform.SetUpModelStack( draw_helper );
      pConeMesh->DrawMesh( false,  /* no texture */
                        true /* show flat color */, m_FlatColor );
    }
    draw_helper.PopModelTransform();
  }
}