// UW Bothell Graphics Library Copyright (c) 2006 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

/// uwbgl_D3D_Lib17.h - Main Include file for version 17 of the UWB Direct3D Graphics Library
/// Include this single header file in your projects to add support for the library.

/// NOTE: There is absolutely no library specific windowing functionality in this library
///       Include the MFC UWBGL library (or other UWBGL windowing library) into your projects
///       to add windowing support.

/// *IMPORTANT*: Header and source files in UWBGL_Direct3D_1 should NEVER include this file.
/// *IMPORTANT*: External projects that use this library should ONLY include this file to get
///              access to all class and functions provided by this library.
#pragma once

#include "uwbgl_D3DDefines.h"       //Direct3D Specific headers and linking instructions

#include "math3d++/math3d++.h"      // math library
using namespace math3d;

#include "uwbgl_Common.h"             //Common headers, symbols, and macros
#include "uwbgl_Containers.h"
#include "uwbgl_IWindowHandler.h"     //Connection to a window
#include "uwbgl_WindowHandler6.h"
#include "uwbgl_Utility2.h"           //Utility functions
#include "uwbgl_Color1.h"
#include "uwbgl_Clock.h"
#include "uwbgl_DrawHelper4.h"

#include "uwbgl_D3DGraphicsSystem6.h" //D3D Graphics System Manager
#include "uwbgl_D3DWindowHandler8.h"  //Generic D3D Window base class
#include "uwbgl_D3DDrawHelper8.h"

#include "uwbgl_Intersect4.h"
#include "uwbgl_XformInfo5.h"
#include "uwbgl_SceneNode6.h"
#include "uwbgl_Camera2.h"

//geometry
#include "uwbgl_Primitive5.h"
#include "uwbgl_PrimitiveCircle5.h"
#include "uwbgl_PrimitiveLine5.h"
#include "uwbgl_PrimitivePoint5.h"
#include "uwbgl_PrimitiveList4.h"
#include "uwbgl_PrimitiveRectXY4.h"
#include "uwbgl_PrimitiveRectXZ2.h"
#include "uwbgl_PrimitiveAxisFrame2.h"

#include "uwbgl_D3DPrimitiveMesh2.h"
#include "uwbgl_D3DPrimitiveMeshAxis3.h"
#include "uwbgl_D3DPrimitiveMeshArrow3.h"