#include "uwbgl_PrimitiveAxisFrame2.h"

UWB_PrimitiveAxisFrame::UWB_PrimitiveAxisFrame()
: m_size(1)
{
}

void UWB_PrimitiveAxisFrame::SetupDrawAttributes(UWB_DrawHelper& draw_helper) 
{
  __super::SetupDrawAttributes(draw_helper);
  draw_helper.SetShadeMode( smFlat );
}

void UWB_PrimitiveAxisFrame::DrawPrimitive(eLevelOfDetail lod, UWB_DrawHelper& draw_helper)
{
  vec3 origin(0,0,0);
  vec3 xaxis(m_size,0,0);
  vec3 yaxis(0,m_size,0);
  vec3 zaxis(0,0,m_size);

  draw_helper.SetColor1(UWB_Color(255,0,0));
  draw_helper.DrawLine( origin, xaxis );

  draw_helper.SetColor1(UWB_Color(0,255,0));
  draw_helper.DrawLine( origin, yaxis );

  draw_helper.SetColor1(UWB_Color(0,0,255));
  draw_helper.DrawLine( origin, zaxis );
}

void UWB_PrimitiveAxisFrame::SetSize( float size )
{
  m_size = fabs(size);
}

float UWB_PrimitiveAxisFrame::GetSize() const
{
  return m_size;
}
