// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_PrimitiveRectXY4.h"

/// A primitive drawing object that represents a planar 2-D rectangle
/// that is drawn parallel to the x-z plane
class UWB_PrimitiveRectangleXZ : public UWB_PrimitiveRectangleXY
{
public:
  /// Initialize the rectangle as a zero size rectangle.
  /// i.e. both corners are at 0,0,0
  UWB_PrimitiveRectangleXZ();

  /// User mouse input handler for this primitive
  /// position is set to the given mouse input location
  virtual void MouseDownVertex(int vertexID, float x, float y);

  /// Mouse user input handler for this primitive
  /// Move the position of the point to a new location
  virtual void MoveTo(float x, float y);

protected:
  /// Virtual drawing routine for this primitive. All of the drawing operations
  /// are called on the draw_helper in order to abstract the graphics API from
  /// the primitive class
  virtual void DrawPrimitive( eLevelOfDetail lod, UWB_DrawHelper& draw_helper );
};
